Page MenuHomePhabricator

QA of Chromium PDF renderer
Closed, ResolvedPublic

Description

Background

We would like to go through the full set of test cases for the Chromium renderer as well as ensure that bugs open in Electron are not replicated in the renderer

Testing criteria

Accessing the service

Currently, service is not accessible via any nice frontend. In order to generate the PDF you have to send the request to the:
https://proton-beta.wmflabs.org/{WIKI}/v1/pdf/{ARTICLE}/{SIZE}/{TYPE}) URL, where:

  • WIKI -> one of wikis, for example en.wikipedia.org, pl.wikipedia.org, jp.wikipedia.org
  • ARTICLE -> the Article title
  • SIZE -> PDF size, one of a4, legal, letter
  • TYPE -> PDF type, one of desktop, mobile
Examples

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptMay 30 2018, 5:36 PM
ovasileva triaged this task as High priority.May 30 2018, 5:37 PM
pmiazga updated the task description. (Show Details)May 30 2018, 5:57 PM

I have been testing today and logging results here:
https://docs.google.com/spreadsheets/d/1CdHhFDoTOfbLDCuwVViAWSFlduNE88h3mCbSKIRbKcs/edit?usp=sharing

I'll keep adding details as I go. So far, no failures that are not known issues (Example: background colors on tables https://www.mediawiki.org/wiki/Reading/Web/Projects/Print_Styles#Limitations).

Jc86035 updated the task description. (Show Details)Jun 1 2018, 3:49 PM
This comment was removed by ABorbaWMF.
This comment was removed by ABorbaWMF.
ABorbaWMF added a comment.EditedJun 4 2018, 6:03 PM

Found some kerning issues also listed in this ticket - T178665

Browser PrintPDF

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Least weasel/letter/desktop

Kerning issues look similar across desktop style PDFs. The kerning issues look less severe on mobile styles

Desktop LetterDesktop A4Desktop Legal
Mobile LetterMobile A4Mobile Legal

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/letter/desktop

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/a4/desktop

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/legal/desktop

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/letter/mobile

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/a4/mobile

https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/legal/mobile

ABorbaWMF added a comment.EditedJun 5 2018, 4:07 PM

We may want a better treatment for audio files in PDFs -


https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Music/letter/desktop

Here is an example of a video file. There is a link to the video that works -


https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Video/letter/desktop

ABorbaWMF added a comment.EditedJun 6 2018, 12:18 AM

There are no 'featured' or 'protected' icons present. Here is the Barack Obama article which is both.


https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/letter/desktop

There are also two 'series' infoboxes in the article which do not appear in the PDF.

WebsitePDF

Note the 2 series infoboxes appear under the main article infobox.

This article has an odd issue with the infobox. In this case the infobox does not start on page 1. So far this is the only article I found that displays this issue.
https://zh.wikipedia.org/wiki/%E9%A9%AC%E9%87%8C%E6%98%82%E5%86%9B%E4%BA%8B%E5%AD%A6%E9%99%A2
https://proton-beta.wmflabs.org/zh.wikipedia.org/v1/pdf/马里昂军事学院/a4/desktop

This article has some issues with the references section. I noticed on the article itself that the reference section has it's own scroll bar.
https://ar.wikipedia.org/wiki/%D9%82%D9%86%D8%A7%D8%A9_%D8%A7%D9%84%D8%B3%D9%88%D9%8A%D8%B3
https://proton-beta.wmflabs.org/ar.wikipedia.org/v1/pdf/قناة السويس/legal/desktop

ABorbaWMF added a comment.EditedJun 6 2018, 12:44 AM

The 1st image in this article has a frame around it with a blue link in the image notes. In PDF form, only the top of the frame appears and the link is not blue.
https://ko.wikipedia.org/wiki/%ED%97%8C%EB%B2%95
https://proton-beta.wmflabs.org/ko.wikipedia.org/v1/pdf/헌법/letter/desktop

WebitePDF

Also appears on mobile PDF

ABorbaWMF added a comment.EditedJun 6 2018, 4:18 PM

This PDF is missing a few items when compared to the article on the website. There is a small box below the infobox that does not appear in the PDF. There are also a number of collapsed tables at the bottom of the article that do not appear in the PDF.
https://ur.wikipedia.org/wiki/%D8%A7%D8%B1%D8%AF%D9%88
https://proton-beta.wmflabs.org/ur.wikipedia.org/v1/pdf/اردو/a4/desktop

WebsitePDF

This article also has tables at the bottom that do not appear in the PDF.
https://bn.wikipedia.org/wiki/%E0%A6%AD%E0%A6%BE%E0%A6%B0%E0%A6%A4
https://proton-beta.wmflabs.org/bn.wikipedia.org/v1/pdf/ভারত/letter/desktop

WebsitePDF

The mobile version of the PDF shows some issues on the Mathematics article. The right edge is cutoff
https://en.wikipedia.org/wiki/Mathematics
https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Mathematics/a4/mobile

MobilePDF
ABorbaWMF added a comment.EditedJun 6 2018, 9:37 PM

The Barack Obama and other articles produce very small images in PDF
https://en.m.wikipedia.org/wiki/Barack_Obama
https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Barack Obama/a4/mobile

MobilePDF

Other examples.




ABorbaWMF updated the task description. (Show Details)Jun 8 2018, 1:19 AM

@ABorbaWMF If you missed it, this may be relevant – I'd assumed in writing the comment (after the issue had been closed) that the renderer was going to be deployed soon, rather than that it was still being tested. Summary: Images are not aligned correctly; images appear to be distorted; the inline CSS colours are gone.

The image – if from Chromium – seems a bit problematic. One of the images is still clearly incorrectly aligned, the one in the Lai King row. This is worrying, because it might mean that the new software is incorrectly rounding the image widths. (The gap between that image and the other images in the row is an empty table cell with a set width.) Several of the images (the corner pieces for the 45° tracks) did not render at all, and many of the ones which did render appear to be quite distorted (the circles should be round, and the curves in the second-last row should be smooth). I can't tell why.
Obviously, these are not problems for most images, but it would be nice if they could be fixed (if they're problems with the renderer). These diagrams are used on more than ten thousand pages across WMF wikis.
In addition, the colours being stripped makes the interchange boxes useless, and the background colour being stripped makes the fade overlays look incorrect because IIRC they are supposed to match #f9f9f9 (the old MediaWiki table background colour). However, this is more of a problem with whatever CSS is being used.

ovasileva added a comment.EditedJun 12 2018, 11:48 AM

@ABorbaWMF - could you take a look at T178664#4248299 again using the chromium renderer? Could also be related to https://bugs.chromium.org/p/chromium/issues/detail?id=741049

Reviewed QA issues with @pmiazga:

Chromium PDF has some issues with the quality of images, usually, images are printed in low-quality images. Probably Chromium has to fix it first:

I can investigate that topic, but I'm not sure if there is anything we can do right now.

Chromium PDF has some issues with the quality of images, usually, images are printed in low-quality images. Probably Chromium has to fix it first:

I can investigate that topic, but I'm not sure if there is anything we can do right now.

Sounds good - seems like we might just want to keep the original task open to note it's still an issue .

This PDF, rendered in Preview.app on macOS, has oversized text which breaks the rows of the diagram table (the images should appear to be continuous). Inexplicably, the images are still rendered at their normal size. Changing the font size is probably not good, since many pages have objects with dimensions specified in pixels.

ovasileva added a subscriber: ABorbaWMF.
ABorbaWMF closed this task as Resolved.Jun 15 2018, 3:58 AM

Found a small issue with a table midway through the document.

https://en.wikipedia.org/wiki/Philosophy_of_mind
https://proton-beta.wmflabs.org/en.wikipedia.org/v1/pdf/Philosophy of mind/letter/desktop

ABorbaWMF reopened this task as Open.Jun 15 2018, 3:59 AM

Mistakenly resolved

ovasileva closed this task as Resolved.Jun 20 2018, 10:23 AM

All follow-up bugs have been opened and prioritized. I think we're done here. Thank you @ABorbaWMF!

Vvjjkkii renamed this task from QA of Chromium PDF renderer to 4ybaaaaaaa.Jul 1 2018, 1:07 AM
Vvjjkkii reopened this task as Open.
Vvjjkkii removed ovasileva as the assignee of this task.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
Jc86035 renamed this task from 4ybaaaaaaa to QA of Chromium PDF renderer.Jul 1 2018, 4:04 AM
Jc86035 closed this task as Resolved.
Jc86035 assigned this task to ovasileva.
Jc86035 updated the task description. (Show Details)
Jc86035 added a subscriber: Aklapper.